<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><title>Vitebsk Miniq 19</title><meta content="yes" name="apple-mobile-web-app-capable"><meta content="black-translucent" name="apple-mobile-web-app-status-bar-style"><meta content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui" name="viewport"><link href="node_modules/reveal.js/css/reveal.css" rel="stylesheet"><link rel="stylesheet" href="node_modules/reveal.js/css/theme/night.css" id="theme"><!--This CSS is generated by the Asciidoctor-Reveal.js converter to further integrate AsciiDoc's existing semantic with Reveal.js--><style type="text/css">.reveal div.right {
  float: right;
}

/* callouts */
.conum[data-value] {display:inline-block;color:#fff!important;background-color:rgba(50,150,50,.8);-webkit-border-radius:100px;border-radius:100px;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]:after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}</style><link href="node_modules/reveal.js/lib/css/zenburn.css" rel="stylesheet"><script>var link = document.createElement( 'link' );
link.rel = 'stylesheet';
link.type = 'text/css';
link.href = window.location.search.match( /print-pdf/gi ) ? "node_modules/reveal.js/css/print/pdf.css" : "node_modules/reveal.js/css/print/paper.css";
document.getElementsByTagName( 'head' )[0].appendChild( link );</script><!--[if lt IE 9]><script src="node_modules/reveal.js/lib/js/html5shiv.js"></script><![endif]--><link rel="stylesheet" href="custom.css"></head><body><div class="reveal"><div class="slides"><section class="title" data-state="title"><h1>Vitebsk Miniq 19</h1></section><section id="_title" data-background-image="images/background.jpg" data-background-size="contain"></section>
<section id="_miniq_19"><h2>Miniq 19</h2><div class="paragraph"><p>:author: Максим Дадеркин</p></div>
<aside class="notes"><div class="paragraph"><p>Документация: её трудно писать, о ней легко забыть и самое главное, её невозможно поддерживать.
Тоже самое можно сказать и про диаграммы.<br></p></div>
<div class="paragraph"><p>Я часто слышу вопросы:<br></p></div>
<div class="ulist"><ul><li><p>Зачем писать документацию?
Eё же потом нужно поддерживать.</p></li><li><p>Я пишу хороший код.
Зачем диграмма?
Тут и так всё понятно.</p></li></ul></div>
<div class="paragraph"><p>В общем, я хочу поделиться с вами своим опытом и постараюсь объяснить зачем нужны диграммы и документация, а также как их вести с минимальными затратами.</p></div></aside>
<pre class="highlight listingblock"><code data-noescape class="text language-text"> ___________
&lt; Диаграммы &gt;          ______________
 -----------          &lt; Документация &gt;    ________________
      \                --------------    &lt; И всё такое... &gt;
       \                    /             ----------------
        \                  /                /
          oO)-.           /           .-(Oo
         /__  _\                     /_  __\
         \  \(  |     ()~()         |  )/  /
          \__|\ |    (-___-)        | /|__/
          '  '--'    ==`-'==        '--'  '</code></pre></section>
<section id="_кто_я"><h2>Кто я?</h2><div class="ulist"><ul><li class="fragment"><p>Team Lead</p></li><li class="fragment"><p>Java, JavaScript, Rust, Go, и др.</p></li><li class="fragment"><p>&#8594; Когда-нибудь стану Solution Architect</p></li><li class="fragment"><p>&#8594; Люблю "рисовать" диграммы &#128522;</p></li></ul></div></section>
<section><div class="quoteblock"><blockquote>"Зачем писать документацию?
Eё же потом нужно поддерживать."<br></blockquote><div class="attribution">&#8212; (Не)известный программист</div></div>
<div class="quoteblock"><blockquote>"Я пишу хороший код.
Зачем диграмма?
Тут и так всё понятно."<br></blockquote><div class="attribution">&#8212; (Не)известный программист</div></div></section>
<section id="_план"><h2>План</h2><div class="ulist"><ul><li class="fragment"><p>Диаграммы</p></li><li class="fragment"><p>Документация</p></li><li class="fragment"><p>и всё такое&#8230;&#8203; :)</p></li></ul></div></section>
<section id="_условные_обозначения"><h2>Условные обозначения</h2><div class="ulist"><ul><li class="fragment"><p>[&#128065;] - демонстрация</p></li><li class="fragment"><p>[?] - будут даны пояснения</p></li></ul></div></section>
<section><section id="_диаграммы"><h2>Диаграммы</h2></section><section id="_что_можно_использовать"><h2>Что можно использовать?</h2><div class="ulist"><ul><li class="fragment"><p>Microsoft Visio</p></li><li class="fragment"><p>Gliffy</p></li><li class="fragment"><p>[&#128065;] Draw.io</p></li><li class="fragment"><p>LucidChart</p></li><li class="fragment"><p>Cacoo</p></li><li class="fragment"><p>[&#128065;] <em>*PlantUML*</em></p></li></ul></div></section><section id="_plantuml"><h2>PlantUML</h2><div class="imageblock" style=""><img src="diagrams/example001.png" alt="500" width="400"></div></section><section id="_uml_диаграммы_часть_1"><h2>UML-диаграммы (Часть 1)</h2><div class="ulist"><ul><li><p>Диаграммы последовательности</p></li><li><p>Диаграммы прецедентов</p></li><li><p>Диаграммы классов</p></li><li><p>Диаграммы активности</p></li><li><p>Диаграммы компонентов</p></li></ul></div></section><section id="_uml_диаграммы_часть_2"><h2>UML-диаграммы (Часть 2)</h2><div class="ulist"><ul><li><p>Диаграммы состояний</p></li><li><p>Диаграммы объектов</p></li><li><p>Диаграмма развёртывания</p></li><li><p>Диаграмма синхронизации</p></li></ul></div></section><section id="_не_uml_диаграммы_часть_1"><h2>Не-UML-диаграммы (Часть 1)</h2><div class="ulist"><ul><li><p>Wireframe graphical interface</p></li><li><p>Archimate diagram</p></li><li><p>Specification and Description Language (SDL)</p></li><li><p>Ditaa diagram</p></li><li><p>Gantt diagram</p></li></ul></div></section><section id="_не_uml_диаграммы_часть_2"><h2>Не-UML-диаграммы (Часть 2)</h2><div class="ulist"><ul><li><p>MindMap diagram</p></li><li><p>Work Breakdown Structure diagram</p></li><li><p>Mathematic with AsciiMath or JLaTeXMath notation</p></li><li><p>Entity Relationship diagram</p></li></ul></div></section><section id="_демо"><h2>Демо</h2><div class="paragraph"><p>&#129488;</p></div></section></section>
<section><section id="_документация"><h2>Документация</h2></section><section id="_что_можно_использовать_2"><h2>Что можно использовать?</h2><div class="ulist"><ul><li class="fragment"><p>Блокнот</p></li><li class="fragment"><p>Wiki (Gitlab/Github/etc.)</p></li><li class="fragment"><p>[&#128065;] Confluence</p></li><li class="fragment"><p><em>*Markdown/AsciiDoc*</em></p></li></ul></div></section><section id="_демо_2"><h2>Демо</h2><div class="paragraph"><p>&#129488;</p></div></section></section>
<section><section id="_и_всё_такое"><h2>И всё такое&#8230;&#8203;</h2></section><section id="_зачем_нужны_диаграммы"><h2>Зачем нужны диаграммы?</h2><div class="ulist"><ul><li class="fragment"><p>Они наглядны</p></li><li class="fragment"><p>Удобны для объяснения/представления</p></li><li class="fragment"><p>Заказчику важно знать <strong>КАК ЭТО РАБОТАЕТ</strong> и редко <em>как это написано</em></p></li><li class="fragment"><p>Кода может и не быть &#128521;</p></li></ul></div></section><section id="_зачем_писать_документацию"><h2>Зачем писать документацию?</h2><div class="ulist"><ul><li class="fragment"><p>Она нужна пользователю</p></li><li class="fragment"><p>Закрепление требований</p><div class="ulist"><ul><li><p>[?] Бизнес изменчив</p></li></ul></div></li><li class="fragment"><p>Централизованный источник знаний</p></li><li class="fragment"><p>Кода может и не быть #2 &#128521;</p></li><li class="fragment"><p>и многое другое&#8230;&#8203;</p></li></ul></div></section><section id="_советы"><h2>Советы</h2><div class="ulist"><ul><li class="fragment"><p>Не бойтесь писать документацию (JavaDoc, JsDoc, Swagger, RAML, etc.)</p></li><li class="fragment"><p>[?] Не стесняйтесь создавать задачи на обновление/создание документации</p></li><li class="fragment"><p>Поддерживайте версионность документации</p></li><li class="fragment"><p>[?] Используйте средства автоматической генерации документации (ОСТОРОЖНО!)</p></li><li class="fragment"><p>Попробуйте PlantUML, Markdown/Asciidoc</p></li></ul></div></section></section>
<section id="_полезные_ссылки"><h2>Полезные ссылки</h2><div class="ulist"><ul><li><p><a href="http://plantuml.com" class="bare">http://plantuml.com</a></p></li><li><p><a href="https://asciidoctor.org/" class="bare">https://asciidoctor.org/</a></p></li><li><p><a href="https://www.markdownguide.org" class="bare">https://www.markdownguide.org</a></p></li><li><p><a href="https://www.atlassian.com/software/confluence" class="bare">https://www.atlassian.com/software/confluence</a></p></li></ul></div></section>
<section><div class="imageblock" style=""><img src="images/question_mark.PNG" alt="600" width="400"></div></section></div></div><script src="node_modules/reveal.js/lib/js/head.min.js"></script><script src="node_modules/reveal.js/js/reveal.js"></script><script>Array.prototype.slice.call(document.querySelectorAll('.slides section')).forEach(function(slide) {
  if (slide.getAttribute('data-background-color')) return;
  // user needs to explicitly say he wants CSS color to override otherwise we might break custom css or theme (#226)
  if (!(slide.classList.contains('canvas') || slide.classList.contains('background'))) return;
  var bgColor = getComputedStyle(slide).backgroundColor;
  if (bgColor !== 'rgba(0, 0, 0, 0)' && bgColor !== 'transparent') {
    slide.setAttribute('data-background-color', bgColor);
    slide.style.backgroundColor = 'transparent';
  }
})

// See https://github.com/hakimel/reveal.js#configuration for a full list of configuration options
Reveal.initialize({
  // Display presentation control arrows
  controls: true,
  // Help the user learn the controls by providing hints, for example by
  // bouncing the down arrow when they first encounter a vertical slide
  controlsTutorial: true,
  // Determines where controls appear, "edges" or "bottom-right"
  controlsLayout: 'bottom-right',
  // Visibility rule for backwards navigation arrows; "faded", "hidden"
  // or "visible"
  controlsBackArrows: 'faded',
  // Display a presentation progress bar
  progress: true,
  // Display the page number of the current slide
  slideNumber: false,
  // Control which views the slide number displays on
  showSlideNumber: 'all',
  // Push each slide change to the browser history
  history: false,
  // Enable keyboard shortcuts for navigation
  keyboard: true,
  // Enable the slide overview mode
  overview: true,
  // Vertical centering of slides
  center: true,
  // Enables touch navigation on devices with touch input
  touch: true,
  // Loop the presentation
  loop: false,
  // Change the presentation direction to be RTL
  rtl: false,
  // Randomizes the order of slides each time the presentation loads
  shuffle: false,
  // Turns fragments on and off globally
  fragments: true,
  // Flags whether to include the current fragment in the URL,
  // so that reloading brings you to the same fragment position
  fragmentInURL: false,
  // Flags if the presentation is running in an embedded mode,
  // i.e. contained within a limited portion of the screen
  embedded: false,
  // Flags if we should show a help overlay when the questionmark
  // key is pressed
  help: true,
  // Flags if speaker notes should be visible to all viewers
  showNotes: false,
  // Global override for autolaying embedded media (video/audio/iframe)
  // - null: Media will only autoplay if data-autoplay is present
  // - true: All media will autoplay, regardless of individual setting
  // - false: No media will autoplay, regardless of individual setting
  autoPlayMedia: null,
  // Number of milliseconds between automatically proceeding to the
  // next slide, disabled when set to 0, this value can be overwritten
  // by using a data-autoslide attribute on your slides
  autoSlide: 0,
  // Stop auto-sliding after user input
  autoSlideStoppable: true,
  // Use this method for navigation when auto-sliding
  autoSlideMethod: Reveal.navigateNext,
  // Specify the average time in seconds that you think you will spend
  // presenting each slide. This is used to show a pacing timer in the
  // speaker view
  defaultTiming: 120,
  // Enable slide navigation via mouse wheel
  mouseWheel: false,
  // Hides the address bar on mobile devices
  hideAddressBar: true,
  // Opens links in an iframe preview overlay
  // Add `data-preview-link` and `data-preview-link="false"` to customise each link
  // individually
  previewLinks: false,
  // Transition style (e.g., none, fade, slide, convex, concave, zoom)
  transition: 'slide',
  // Transition speed (e.g., default, fast, slow)
  transitionSpeed: 'default',
  // Transition style for full page slide backgrounds (e.g., none, fade, slide, convex, concave, zoom)
  backgroundTransition: 'fade',
  // Number of slides away from the current that are visible
  viewDistance: 3,
  // Parallax background image (e.g., "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'")
  parallaxBackgroundImage: '',
  // Parallax background size in CSS syntax (e.g., "2100px 900px")
  parallaxBackgroundSize: '',
  // Number of pixels to move the parallax background per slide
  // - Calculated automatically unless specified
  // - Set to 0 to disable movement along an axis
  parallaxBackgroundHorizontal: null,
  parallaxBackgroundVertical: null,
  // The display mode that will be used to show slides
  display: 'block',

  // The "normal" size of the presentation, aspect ratio will be preserved
  // when the presentation is scaled to fit different resolutions. Can be
  // specified using percentage units.
  width: 960,
  height: 700,

  // Factor of the display size that should remain empty around the content
  margin: 0.1,

  // Bounds for smallest/largest possible scale to apply to content
  minScale: 0.2,
  maxScale: 1.5,

  // Optional libraries used to extend on reveal.js
  dependencies: [
      { src: 'node_modules/reveal.js/lib/js/classList.js', condition: function() { return !document.body.classList; } },
      { src: 'node_modules/reveal.js/plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
      { src: 'node_modules/reveal.js/plugin/zoom-js/zoom.js', async: true },
      { src: 'node_modules/reveal.js/plugin/notes/notes.js', async: true },
      
      
      { src: 'node_modules/reveal.js/plugin/print-pdf/print-pdf.js', async: true },
      
  ],

  

});</script></body></html>